diff --git a/gcc/ada/libgnat/s-dwalin.adb b/gcc/ada/libgnat/s-dwalin.adb
index d8b15c5dd66..7135b7ab25d 100644
--- a/gcc/ada/libgnat/s-dwalin.adb
+++ b/gcc/ada/libgnat/s-dwalin.adb
@@ -921,31 +1091,53 @@ package body System.Dwarf_Lines is
       Ptr_Sz :        uint8)
    is
       Skip : Offset;
+
    begin
+      --  7.5.5 Classes and Forms
+
       case Form is
          when DW_FORM_addr =>
             Skip := Offset (Ptr_Sz);
+         when DW_FORM_addrx =>
+            Skip := Offset (uint32'(Read_LEB128 (S)));
+         when DW_FORM_block1 =>
+            Skip := Offset (uint8'(Read (S)));
          when DW_FORM_block2 =>
             Skip := Offset (uint16'(Read (S)));
          when DW_FORM_block4 =>
             Skip := Offset (uint32'(Read (S)));
-         when DW_FORM_data2 | DW_FORM_ref2 =>
-            Skip := 2;
-         when DW_FORM_data4 | DW_FORM_ref4 =>
-            Skip := 4;
-         when DW_FORM_data8 | DW_FORM_ref8 | DW_FORM_ref_sig8 =>
-            Skip := 8;
-         when DW_FORM_string =>
-            while uint8'(Read (S)) /= 0 loop
-               null;
-            end loop;
-            return;
          when DW_FORM_block | DW_FORM_exprloc =>
             Skip := Offset (uint32'(Read_LEB128 (S)));
-         when DW_FORM_block1 | DW_FORM_ref1 =>
-            Skip := Offset (uint8'(Read (S)));
-         when DW_FORM_data1 | DW_FORM_flag =>
+         when DW_FORM_addrx1
+            | DW_FORM_data1
+            | DW_FORM_flag
+            | DW_FORM_ref1
+            | DW_FORM_strx1
+           =>
             Skip := 1;
+         when DW_FORM_addrx2
+            | DW_FORM_data2
+            | DW_FORM_ref2
+            | DW_FORM_strx2
+           =>
+            Skip := 2;
+         when DW_FORM_addrx3 | DW_FORM_strx3 =>
+            Skip := 3;
+         when DW_FORM_addrx4
+            | DW_FORM_data4
+            | DW_FORM_ref4
+            | DW_FORM_ref_sup4
+            | DW_FORM_strx4
+           =>
+            Skip := 4;
+         when DW_FORM_data8
+            | DW_FORM_ref8
+            | DW_FORM_ref_sup8
+            | DW_FORM_ref_sig8
+           =>
+            Skip := 8;
+         when DW_FORM_data16 =>
+            Skip := 16;
          when DW_FORM_sdata =>
             declare
                Val : constant int32 := Read_LEB128 (S);
@@ -953,9 +1145,12 @@ package body System.Dwarf_Lines is
             begin
                return;
             end;
-         when DW_FORM_strp | DW_FORM_ref_addr | DW_FORM_sec_offset =>
-            Skip := (if Is64 then 8 else 4);
-         when DW_FORM_udata | DW_FORM_ref_udata =>
+         when DW_FORM_udata
+            | DW_FORM_ref_udata
+            | DW_FORM_loclistx
+            | DW_FORM_rnglistx
+            | DW_FORM_strx
+           =>
             declare
                Val : constant uint32 := Read_LEB128 (S);
                pragma Unreferenced (Val);
@@ -964,11 +1159,24 @@ package body System.Dwarf_Lines is
             end;
          when DW_FORM_flag_present =>
             return;
-         when DW_FORM_indirect =>
+         when DW_FORM_ref_addr
+            | DW_FORM_sec_offset
+            | DW_FORM_strp
+            | DW_FORM_line_strp
+            | DW_FORM_strp_sup
+           =>
+            Skip := (if Is64 then 8 else 4);
+         when DW_FORM_string =>
+            while uint8'(Read (S)) /= 0 loop
+               null;
+            end loop;
+            return;
+         when DW_FORM_implicit_const | DW_FORM_indirect =>
             raise Constraint_Error;
          when others =>
             raise Constraint_Error;
       end case;
+
       Seek (S, Tell (S) + Skip);
    end Skip_Form;
 
@@ -981,20 +1189,21 @@ package body System.Dwarf_Lines is
       Abbrev_Offset :        Offset;
       Abbrev_Num    :        uint32)
    is
-      Num       : uint32;
       Abbrev    : uint32;
       Tag       : uint32;
       Has_Child : uint8;
-      pragma Unreferenced (Abbrev, Tag, Has_Child);
+      pragma Unreferenced (Tag, Has_Child);
+
    begin
       Seek (C.Abbrev, Abbrev_Offset);
 
-      Num := 1;
+      --  7.5.3 Abbreviations Tables
 
       loop
-         exit when Num = Abbrev_Num;
+         Abbrev := Read_LEB128 (C.Abbrev);
+
+         exit when Abbrev = Abbrev_Num;
 
-         Abbrev    := Read_LEB128 (C.Abbrev);
          Tag       := Read_LEB128 (C.Abbrev);
          Has_Child := Read (C.Abbrev);
 
@@ -1002,12 +1211,19 @@ package body System.Dwarf_Lines is
             declare
                Name : constant uint32 := Read_LEB128 (C.Abbrev);
                Form : constant uint32 := Read_LEB128 (C.Abbrev);
+               Cst  : int32;
+               pragma Unreferenced (Cst);
+
             begin
-               exit when Name = 0 and Form = 0;
+               --  DW_FORM_implicit_const takes its value from the table
+
+               if Form = DW_FORM_implicit_const then
+                  Cst := Read_LEB128 (C.Abbrev);
+               end if;
+
+               exit when Name = 0 and then Form = 0;
             end;
          end loop;
-
-         Num := Num + 1;
       end loop;
    end Seek_Abbrev;
 
@@ -1029,23 +1245,40 @@ package body System.Dwarf_Lines is
       Abbrev        : uint32;
       Has_Child     : uint8;
       pragma Unreferenced (Has_Child);
+      Unit_Type     : uint8;
+      pragma Unreferenced (Unit_Type);
+
    begin
       Line_Offset := 0;
       Success := False;
 
       Seek (C.Info, Info_Offset);
 
+      --  7.5.1.1 Compilation Unit Header
+
       Read_Initial_Length (C.Info, Unit_Length, Is64);
 
       Version := Read (C.Info);
-      if Version not in 2 .. 4 then
-         return;
-      end if;
 
-      Read_Section_Offset (C.Info, Abbrev_Offset, Is64);
+      if Version >= 5 then
+         Unit_Type := Read (C.Info);
+
+         Addr_Sz := Read (C.Info);
+         if Addr_Sz /= (Address'Size / SSU) then
+            return;
+         end if;
+
+         Read_Section_Offset (C.Info, Abbrev_Offset, Is64);
+
+      elsif Version >= 2 then
+         Read_Section_Offset (C.Info, Abbrev_Offset, Is64);
+
+         Addr_Sz := Read (C.Info);
+         if Addr_Sz /= (Address'Size / SSU) then
+            return;
+         end if;
 
-      Addr_Sz := Read (C.Info);
-      if Addr_Sz /= (Address'Size / SSU) then
+      else
          return;
       end if;
 
@@ -1060,17 +1293,9 @@ package body System.Dwarf_Lines is
 
       Seek_Abbrev (C, Abbrev_Offset, Abbrev);
 
-      --  First ULEB128 is the abbrev code
-
-      if Read_LEB128 (C.Abbrev) /= Abbrev then
-         --  Ill formed abbrev table
-         return;
-      end if;
-
       --  Then the tag
 
       if Read_LEB128 (C.Abbrev) /= uint32'(DW_TAG_Compile_Unit) then
-         --  Expect compile unit
          return;
       end if;
 
@@ -1104,8 +1329,6 @@ package body System.Dwarf_Lines is
             end if;
          end;
       end loop;
-
-      return;
    end Debug_Info_Lookup;
 
    -------------------------
@@ -1121,6 +1344,7 @@ package body System.Dwarf_Lines is
       Is64        : Boolean;
       Version     : uint16;
       Sz          : uint8;
+
    begin
       Success     := False;
       Info_Offset := 0;
@@ -1149,6 +1373,7 @@ package body System.Dwarf_Lines is
       end if;
 
       --  Handle alignment on twice the address size
+
       declare
          Cur_Off : constant Offset := Tell (C.Aranges);
          Align   : constant Offset := 2 * Address'Size / SSU;
@@ -1173,6 +1398,7 @@ package body System.Dwarf_Lines is
    is
    begin
       --  Read table
+
       if Address'Size = 32 then
          declare
             S, L : uint32;
@@ -1182,6 +1408,7 @@ package body System.Dwarf_Lines is
             Start := Storage_Offset (S);
             Len   := Storage_Count (L);
          end;
+
       elsif Address'Size = 64 then
          declare
             S, L : uint64;
@@ -1191,6 +1418,7 @@ package body System.Dwarf_Lines is
             Start := Storage_Offset (S);
             Len   := Storage_Count (L);
          end;
+
       else
          raise Constraint_Error;
       end if;
@@ -1202,8 +1430,11 @@ package body System.Dwarf_Lines is
 
    procedure Enable_Cache (C : in out Dwarf_Context) is
       Cache : Search_Array_Access;
+
    begin
-      --  Phase 1: count number of symbols. Phase 2: fill the cache.
+      --  Phase 1: count number of symbols.
+      --  Phase 2: fill the cache.
+
       declare
          S               : Object_Symbol;
          Val             : uint64;
@@ -1220,6 +1451,7 @@ package body System.Dwarf_Lines is
             while S /= Null_Symbol loop
                --  Discard symbols of length 0 or located outside of the
                --  execution code section outer boundaries.
+
                Sz := uint32 (Size (S));
                Val := Value (S);
 
@@ -1227,11 +1459,11 @@ package body System.Dwarf_Lines is
                  and then Val >= Xcode_Low
                  and then Val <= Xcode_High
                then
-
                   Addr := uint32 (Val - Xcode_Low);
 
                   --  Try to filter symbols at the same address. This is a best
                   --  effort as they might not be consecutive.
+
                   if Addr /= Prev_Addr then
                      Nbr_Symbols := Nbr_Symbols + 1;
                      Prev_Addr   := Addr;
@@ -1251,6 +1483,7 @@ package body System.Dwarf_Lines is
 
             if Phase = 1 then
                --  Allocate the cache
+
                Cache   := new Search_Array (1 .. Nbr_Symbols);
                C.Cache := Cache;
             end if;
@@ -1258,13 +1491,16 @@ package body System.Dwarf_Lines is
          pragma Assert (Nbr_Symbols = C.Cache'Last);
       end;
 
-      --  Sort the cache.
+      --  Sort the cache
+
       Sort_Search_Array (C.Cache.all);
 
       --  Set line offsets
+
       if not C.Has_Debug then
          return;
       end if;
+
       declare
          Info_Offset : Offset;
          Line_Offset : Offset;
@@ -1285,6 +1521,7 @@ package body System.Dwarf_Lines is
             exit when not Success;
 
             --  Read table
+
             loop
                Read_Aranges_Entry (C, Ar_Start, Ar_Len);
                exit when Ar_Start = 0 and Ar_Len = 0;
@@ -1293,6 +1530,7 @@ package body System.Dwarf_Lines is
                Start := uint32 (Ar_Start - C.Low);
 
                --  Search START in the array
+
                First := Cache'First;
                Last  := Cache'Last;
                Mid := First;  --  In case of array with one element
@@ -1307,9 +1545,10 @@ package body System.Dwarf_Lines is
                   end if;
                end loop;
 
-               --  Fill info.
+               --  Fill info
 
                --  There can be overlapping symbols
+
                while Mid > Cache'First
                  and then Cache (Mid - 1).First <= Start
                  and then Cache (Mid - 1).First + Cache (Mid - 1).Size > Start
@@ -1321,9 +1560,11 @@ package body System.Dwarf_Lines is
                     and then Start + Len > Cache (Mid).First
                   then
                      --  MID is within the bounds
+
                      Cache (Mid).Line := uint32 (Line_Offset);
                   elsif Start + Len <= Cache (Mid).First then
                      --  Over
+
                      exit;
                   end if;
                   Mid := Mid + 1;
@@ -1350,7 +1591,7 @@ package body System.Dwarf_Lines is
 
       procedure Set_Result (Match : Line_Info_Registers) is
          Dir_Idx : uint32;
-         J       : uint32;
+         Off     : Offset;
 
          Mod_Time : uint32;
          pragma Unreferenced (Mod_Time);
@@ -1358,46 +1599,123 @@ package body System.Dwarf_Lines is
          Length : uint32;
          pragma Unreferenced (Length);
 
+         Directory_Entry_Format : Entry_Format_Array
+           renames C.Header.Directory_Entry_Format;
+
+         File_Entry_Format : Entry_Format_Array
+           renames C.Header.File_Name_Entry_Format;
+
       begin
-         Seek (C.Lines, C.Prologue.File_Names_Offset);
+         Seek (C.Lines, C.Header.File_Names);
+         Dir_Idx := 0;
 
-         --  Find the entry
+         --  Find the entry. Note that, up to DWARF 4, the index is 1-based
+         --  whereas, in DWARF 5, it is 0-based.
 
-         J := 0;
-         loop
-            J         := J + 1;
-            File_Name := Read_C_String (C.Lines);
+         if C.Header.Version <= 4 then
+            for J in 1 .. Match.File loop
+               File_Name := Read_C_String (C.Lines);
 
-            if File_Name (File_Name'First) = ASCII.NUL then
-               --  End of file list, so incorrect entry
-               return;
-            end if;
+               if File_Name (File_Name'First) = ASCII.NUL then
+                  --  End of file list, so incorrect entry
+                  return;
+               end if;
 
-            Dir_Idx  := Read_LEB128 (C.Lines);
-            Mod_Time := Read_LEB128 (C.Lines);
-            Length   := Read_LEB128 (C.Lines);
-            exit when J = Match.File;
-         end loop;
+               Dir_Idx  := Read_LEB128 (C.Lines);
+               Mod_Time := Read_LEB128 (C.Lines);
+               Length   := Read_LEB128 (C.Lines);
+            end loop;
+
+            if Dir_Idx = 0 then
+               --  No directory
+
+               Dir_Name := null;
+
+            else
+               Seek (C.Lines, C.Header.Directories);
+
+               for J in 1 .. Dir_Idx loop
+                  Dir_Name := Read_C_String (C.Lines);
 
-         if Dir_Idx = 0 then
-            --  No directory
-            Dir_Name := null;
+                  if Dir_Name (Dir_Name'First) = ASCII.NUL then
+                     --  End of directory list, so ill-formed table
+
+                     return;
+                  end if;
+               end loop;
+            end if;
+
+         --  DWARF 5
 
          else
-            Seek (C.Lines, C.Prologue.Includes_Offset);
+            for J in 0 .. Match.File loop
+               for K in 1 .. Integer (C.Header.File_Name_Entry_Format_Count)
+               loop
+                  if File_Entry_Format (K).C_Type = DW_LNCT_path then
+                     case File_Entry_Format (K).Form is
+                        when DW_FORM_string =>
+                           File_Name := Read_C_String (C.Lines);
 
-            J := 0;
-            loop
-               J        := J + 1;
-               Dir_Name := Read_C_String (C.Lines);
+                        when DW_FORM_line_strp =>
+                           Read_Section_Offset (C.Lines, Off, C.Header.Is64);
+                           Seek (C.Line_Str, Off);
+                           File_Name := Read_C_String (C.Line_Str);
 
-               if Dir_Name (Dir_Name'First) = ASCII.NUL then
-                  --  End of directory list, so ill-formed table
-                  return;
-               end if;
+                        when others =>
+                           raise Dwarf_Error with "DWARF form not implemented";
+                     end case;
+
+                  elsif File_Entry_Format (K).C_Type = DW_LNCT_directory_index
+                  then
+                     case File_Entry_Format (K).Form is
+                        when DW_FORM_data1 =>
+                           Dir_Idx := uint32 (uint8'(Read (C.Lines)));
+
+                        when DW_FORM_data2 =>
+                           Dir_Idx := uint32 (uint16'(Read (C.Lines)));
+
+                        when DW_FORM_udata =>
+                           Dir_Idx := Read_LEB128 (C.Lines);
 
-               exit when J = Dir_Idx;
+                        when others =>
+                           raise Dwarf_Error with "invalid DWARF";
+                     end case;
 
+                  else
+                     Skip_Form (C.Lines,
+                       File_Entry_Format (K).Form,
+                       C.Header.Is64,
+                       C.Header.Address_Size);
+                  end if;
+               end loop;
+            end loop;
+
+            Seek (C.Lines, C.Header.Directories);
+
+            for J in 0 .. Dir_Idx loop
+               for K in 1 .. Integer (C.Header.Directory_Entry_Format_Count)
+               loop
+                  if Directory_Entry_Format (K).C_Type = DW_LNCT_path then
+                     case Directory_Entry_Format (K).Form is
+                        when DW_FORM_string =>
+                           Dir_Name := Read_C_String (C.Lines);
+
+                        when DW_FORM_line_strp =>
+                           Read_Section_Offset (C.Lines, Off, C.Header.Is64);
+                           Seek (C.Line_Str, Off);
+                           Dir_Name := Read_C_String (C.Line_Str);
+
+                        when others =>
+                           raise Dwarf_Error with "DWARF form not implemented";
+                     end case;
+
+                  else
+                     Skip_Form (C.Lines,
+                       Directory_Entry_Format (K).Form,
+                       C.Header.Is64,
+                       C.Header.Address_Size);
+                  end if;
+               end loop;
             end loop;
          end if;
 
@@ -1414,13 +1732,15 @@ package body System.Dwarf_Lines is
 
    begin
       --  Initialize result
+
       Dir_Name    := null;
       File_Name   := null;
       Subprg_Name := (null, 0);
       Line_Num    := 0;
 
+      --  Look up the symbol in the cache
+
       if C.Cache /= null then
-         --  Look in the cache
          declare
             Addr_Off         : constant uint32 := uint32 (Addr - C.Low);
             First, Last, Mid : Natural;
@@ -1447,12 +1767,13 @@ package body System.Dwarf_Lines is
                S := Read_Symbol (C.Obj.all, Offset (C.Cache (Mid).Sym));
                Subprg_Name := Object_Reader.Name (C.Obj.all, S);
             else
-               --  Not found
                return;
             end if;
          end;
+
+      --  Search for the symbol in the binary
+
       else
-         --  Search symbol
          S := First_Symbol (C.Obj.all);
          while S /= Null_Symbol loop
             if Spans (S, Addr_Int) then
@@ -1479,15 +1800,15 @@ package body System.Dwarf_Lines is
       end if;
 
       Seek (C.Lines, Line_Offset);
-      C.Next_Prologue := 0;
+      C.Next_Header := 0;
       Initialize_State_Machine (C);
-      Parse_Prologue (C);
+      Parse_Header (C);
       Previous_Row.Line := 0;
 
       --  Advance to the first entry
 
       loop
-         Read_And_Execute_Isn (C, Done);
+         Read_And_Execute_Insn (C, Done);
 
          if C.Registers.Is_Row then
             Previous_Row := C.Registers;
@@ -1499,8 +1820,8 @@ package body System.Dwarf_Lines is
 
       --  Read the rest of the entries
 
-      while Tell (C.Lines) < C.Next_Prologue loop
-         Read_And_Execute_Isn (C, Done);
+      while Tell (C.Lines) < C.Next_Header loop
+         Read_And_Execute_Insn (C, Done);
 
          if C.Registers.Is_Row then
             if not Previous_Row.End_Sequence
@@ -1533,6 +1854,7 @@ package body System.Dwarf_Lines is
             return I - Str'First;
          end if;
       end loop;
+
       return Str'Last;
    end String_Length;
 
@@ -1558,6 +1880,7 @@ package body System.Dwarf_Lines is
       Subprg_Name : String_Ptr_Len;
       Line_Num    : Natural;
       Off         : Natural;
+
    begin
       if not C.Has_Debug then
          Symbol_Found := False;
@@ -1657,4 +1980,5 @@ package body System.Dwarf_Lines is
          Append (Res, ASCII.LF);
       end loop;
    end Symbolic_Traceback;
+
 end System.Dwarf_Lines;
diff --git a/gcc/ada/libgnat/s-dwalin.ads b/gcc/ada/libgnat/s-dwalin.ads
index 072f089509e..77d3cdf71c9 100644
--- a/gcc/ada/libgnat/s-dwalin.ads
+++ b/gcc/ada/libgnat/s-dwalin.ads
@@ -30,13 +30,10 @@
 ------------------------------------------------------------------------------
 
 --  This package provides routines to read DWARF line number information from
---  a generic object file with as little overhead as possible. This allows
---  conversions from PC addresses to human readable source locations.
+--  a binary file with as little overhead as possible. This allows conversions
+--  from PC addresses to human-readable source locations.
 --
---  Objects must be built with debugging information, however only the
---  .debug_line section of the object file is referenced. In cases where object
---  size is a consideration it's possible to strip all other .debug sections,
---  which will decrease the size of the object significantly.
+--  Files must be compiled with at least minimal debugging information (-g1).
 
 with Ada.Exceptions.Traceback;
 
@@ -50,11 +47,11 @@ package System.Dwarf_Lines is
    package SOR renames System.Object_Reader;
 
    type Dwarf_Context (In_Exception : Boolean := False) is private;
-   --  Type encapsulation the state of the Dwarf reader. When In_Exception
-   --  is True we are parsing as part of a exception handler decorator, we do
-   --  not want an exception to be raised, the parsing is done safely skipping
-   --  DWARF file that cannot be read or with stripped debug section for
-   --  example.
+   --  Type encapsulating the state of the DWARF reader. When In_Exception is
+   --  True, we are parsing as part of an exception handler decorator so we do
+   --  not want another exception to be raised and the parsing is done safely,
+   --  skipping binary files that cannot be read or have been stripped from
+   --  their debug sections for example.
 
    procedure Open
      (File_Name :     String;
@@ -65,14 +62,13 @@ package System.Dwarf_Lines is
 
    procedure Set_Load_Address (C : in out Dwarf_Context; Addr : Address);
    --  Set the load address of a file. This is used to rebase PIE (Position
-   --  Independant Executable) binaries.
+   --  Independent Executable) binaries.
 
    function Is_Inside (C : Dwarf_Context; Addr : Address) return Boolean;
    pragma Inline (Is_Inside);
    --  Return true iff a run-time address Addr is within the module
 
-   function Low_Address (C : Dwarf_Context)
-      return System.Address;
+   function Low_Address (C : Dwarf_Context) return System.Address;
    pragma Inline (Low_Address);
    --  Return the lowest address of C, accounting for the module load address
 
@@ -83,7 +79,7 @@ package System.Dwarf_Lines is
    --  Dump the cache (if present)
 
    procedure Enable_Cache (C : in out Dwarf_Context);
-   --  Read symbols information to speed up Symbolic_Traceback.
+   --  Read symbol information to speed up Symbolic_Traceback.
 
    procedure Symbolic_Traceback
      (Cin          :        Dwarf_Context;
@@ -102,45 +98,64 @@ package System.Dwarf_Lines is
 private
    --  The following section numbers reference
 
-   --    "DWARF Debugging Information Format, Version 3"
+   --    "DWARF Debugging Information Format, Version 5"
 
    --  published by the Standards Group, http://freestandards.org.
 
    --  6.2.2 State Machine Registers
 
    type Line_Info_Registers is record
-      Address        : SOR.uint64;
-      File           : SOR.uint32;
-      Line           : SOR.uint32;
-      Column         : SOR.uint32;
-      Is_Stmt        : Boolean;
-      Basic_Block    : Boolean;
-      End_Sequence   : Boolean;
-      Prologue_End   : Boolean;
-      Epilogue_Begin : Boolean;
-      ISA            : SOR.uint32;
-      Is_Row         : Boolean;
+      Address            : SOR.uint64;
+      File               : SOR.uint32;
+      Line               : SOR.uint32;
+      Column             : SOR.uint32;
+      Is_Stmt            : Boolean;
+      Basic_Block        : Boolean;
+      End_Sequence       : Boolean;
+      --  Prologue_End   : Boolean;
+      --  Epilogue_Begin : Boolean;
+      --  ISA            : SOR.uint32;
+      --  Discriminator  : SOR.uint32;  -- DWARF 4/5
+      Is_Row             : Boolean;     -- local
    end record;
 
-   --  6.2.4 The Line Number Program Prologue
-
-   MAX_OPCODE_LENGTHS : constant := 256;
-
-   type Opcodes_Lengths_Array is
-     array (SOR.uint32 range 1 .. MAX_OPCODE_LENGTHS) of SOR.uint8;
-
-   type Line_Info_Prologue is record
-      Unit_Length       : SOR.uint32;
-      Version           : SOR.uint16;
-      Prologue_Length   : SOR.uint32;
-      Min_Isn_Length    : SOR.uint8;
-      Default_Is_Stmt   : SOR.uint8;
-      Line_Base         : SOR.int8;
-      Line_Range        : SOR.uint8;
-      Opcode_Base       : SOR.uint8;
-      Opcode_Lengths    : Opcodes_Lengths_Array;
-      Includes_Offset   : SOR.Offset;
-      File_Names_Offset : SOR.Offset;
+   --  6.2.4 The Line Number Program Header
+
+   MAX_OPCODE : constant := 256;
+
+   type Opcode_Length_Array is array (1 .. MAX_OPCODE) of SOR.uint8;
+
+   MAX_ENTRY : constant := 5;
+
+   type Entry_Format_Pair is record
+      C_Type : SOR.uint32;
+      Form   : SOR.uint32;
+   end record;
+
+   type Entry_Format_Array is array (1 .. MAX_ENTRY) of Entry_Format_Pair;
+
+   type Line_Info_Header is record
+      Unit_Length                  : SOR.Offset;
+      Version                      : SOR.uint16;
+      Address_Size                 : SOR.uint8;           -- DWARF 5
+      Segment_Selector_Size        : SOR.uint8;           -- DWARF 5
+      Header_Length                : SOR.uint32;
+      Minimum_Insn_Length          : SOR.uint8;
+      Maximum_Op_Per_Insn          : SOR.uint8;           -- DWARF 4/5
+      Default_Is_Stmt              : SOR.uint8;
+      Line_Base                    : SOR.int8;
+      Line_Range                   : SOR.uint8;
+      Opcode_Base                  : SOR.uint8;
+      --  Standard_Opcode_Lengths  : Opcode_Length_Array;
+      Directory_Entry_Format_Count : SOR.uint8;           -- DWARF 5
+      Directory_Entry_Format       : Entry_Format_Array;  -- DWARF 5
+      Directories_Count            : SOR.uint32;          -- DWARF 5
+      Directories                  : SOR.Offset;
+      File_Name_Entry_Format_Count : SOR.uint8;           -- DWARF 5
+      File_Name_Entry_Format       : Entry_Format_Array;  -- DWARF 5
+      File_Names_Count             : SOR.uint32;          -- DWARF 5
+      File_Names                   : SOR.Offset;
+      Is64                         : Boolean;             -- local
    end record;
 
    type Search_Entry is record
@@ -175,15 +190,16 @@ private
       Cache : Search_Array_Access;
       --  Quick access to symbol and debug info (when present).
 
-      Lines   : SOR.Mapped_Stream;
-      Aranges : SOR.Mapped_Stream;
-      Info    : SOR.Mapped_Stream;
-      Abbrev  : SOR.Mapped_Stream;
-      --  Dwarf line, aranges, info and abbrev sections
+      Abbrev   : SOR.Mapped_Stream;
+      Aranges  : SOR.Mapped_Stream;
+      Info     : SOR.Mapped_Stream;
+      Lines    : SOR.Mapped_Stream;
+      Line_Str : SOR.Mapped_Stream;  -- DWARF 5
+      --  DWARF sections
 
-      Prologue      : Line_Info_Prologue;
-      Registers     : Line_Info_Registers;
-      Next_Prologue : SOR.Offset;
+      Header      : Line_Info_Header;
+      Registers   : Line_Info_Registers;
+      Next_Header : SOR.Offset;
       --  State for lines
    end record;
 

